
/* 
 * A sample implementation of integer lists
 * Implementation not hidden away inside the 
 * List module
 */


/* ------------------------------------------------------------ */

object List {

  def empty ():List = new ListEmpty()

  def cons (v:Int,l:List):List = new ListCons(v,l)
}


/* ------------------------------------------------------------ */

abstract class List {

  def isEmpty ():Boolean
  def first ():Int
  def rest ():List
  def find (f:Int):Boolean

  def append (M:List):List
}


/* ------------------------------------------------------------ */

class ListEmpty () extends List {

  def isEmpty ():Boolean = true
  def first ():Int = throw new RuntimeException("Empty.first()")
  def rest ():List = throw new RuntimeException("Empty.rest()")
  def find (f:Int):Boolean = false
  def append (M:List):List = M

  override def toString ():String = ""
}


/* ------------------------------------------------------------ */
 
class ListCons (v:Int,r:List) extends List {

  def isEmpty ():Boolean = false
  def first ():Int = v
  def rest ():List = r
  def find (f:Int):Boolean = 
    (f==v) || r.find(f)
  def append (M:List):List = List.cons(v,r.append(M))

  override def toString ():String = v + " " + r
}
