
trait Ordered[T <: Ordered[T]] { this:T =>     // self type!

  // needs to tbe defined

  def <= (v:T):Boolean

  // all of these definitions are derived from the one above

  def >= (v:T):Boolean = v <= this
  def === (v:T):Boolean = (v <= this) && (v >= this)
  def isEqual (v:T):Boolean = this===v
  def <> (v:T):Boolean = !(v===this)
  def < (v:T):Boolean = (this <= v) && (this <> v)
  def > (v:T):Boolean = (v < this)
}
