
object Test {

  def main (argv:Array[String]):Unit = run()

  def run ():Unit = {

    // Trees of Int

    val T = BinTree

    val T1:BinTree[Int] = T.node(33,
				 T.node(66,
					T.node(99,T.empty(),T.empty()),
					T.empty()),
				 T.node(11,
					T.node(22,T.empty(),T.empty()),
					T.node(44,T.empty(),T.empty())))
    println("T1 = " + T1)
    println("Elements T1 = ")
    T1.print()

    // Trees of Pairs of Ints

    val p0:Pair[Int,Int] = Pair.create(0,0)
    val p1:Pair[Int,Int] = Pair.create(1,2)
    val p2:Pair[Int,Int] = Pair.create(30,40)
    val p3:Pair[Int,Int] = Pair.create(500,600)
    val p4:Pair[Int,Int] = Pair.create(7000,8000)
    
    val T3:BinTree[Pair[Int,Int]] =
      T.node(p1,
	     T.node(p2,T.empty(),T.empty()),
	     T.node(p3,
		    T.node(p4,
			   T.empty(), T.empty()),
		    T.empty()))
    println("T3 = " + T3)
    println("Elements T3 = ")
    T3.print()

    // working with more interesting pairs

    val pp0:Pair[Int,Pair[Int,Int]] = Pair.create(0,p0)
    val pp1:Pair[Int,Pair[Int,Int]] = Pair.create(1,p1)
    val pp2:Pair[Int,Pair[Int,Int]] = Pair.create(2,p2)
    val pp3:Pair[Int,Pair[Int,Int]] = Pair.create(3,p3)
    val pp4:Pair[Int,Pair[Int,Int]] = Pair.create(4,p4)
    
    val T4:BinTree[Pair[Int,Pair[Int,Int]]] =
      T.node(pp1,
	     T.node(pp2,T.empty(),T.empty()),
	     T.node(pp3,
		    T.node(pp4,
			   T.empty(), T.empty()),
		    T.empty()))
    println("T4 = " + T4)
    println("Elements T4 = ")
    T4.print()

    println("--------------------------------------------------")
    println("Elements sequence(T1,T1) = ")
    T1.sequence(T1).print()

    println("--------------------------------------------------")
    println("Constant(99) = ")
    Stream.constant(99).printN(10)

    println("--------------------------------------------------")
    println("intsFrom(10) = ")
    Stream.intsFrom(10).printN(10)

    println("--------------------------------------------------")
    println("Zip(Constant(99),IntsFrom(3)) = ")
    Stream.constant(99).zip(Stream.intsFrom(3)).printN(10)

    println("--------------------------------------------------")
    println("Zip(Constant(99),T1) = ")
    Stream.constant(99).zip(T3).printN(10)

    println("--------------------------------------------------")
    def square (x:Int):Int = x*x
    println("Squares = ")
    Stream.intsFrom(1).map(square).printN(10)

    println("--------------------------------------------------")
    def digitCheck (x:Int):Boolean = (x%10 <= 5)
    println("Squares with last digit <= 5 = ")
    Stream.intsFrom(1).map(square).filter(digitCheck).printN(10)

  }
}
